clear all; clc;
% read in image and change to grayscale
A = rgb2gray(imread('p2.jpg'));

[~,nc] = size(A); 
% resize to minimize so much computation
A = imresize(A, 256/nc, 'nearest');

%B will be our adjusted "path" matrix
B = A;
% Lets keep in mind the number of rows in columns for termination purposes
[numrows,numcol] = size(A); 

% robot start location
xStart = (numcol./2);
yStart = numrows;

avg = 0; avg = cast(avg, 'uint16');%avg = typecast(avg, 'uint16')

% change image to black and white
A = im2bw(A, .5);
A = 255.*A;
% get your starting point
xCurrent = xStart;
yCurrent = yStart;
figure(1); imshow(A);
stop = 0;

B(xCurrent,yCurrent) = 255;
% Time to start chugging through the image

% Begin at start and examine forward pixels to determine which direction to go
% Robot can move straight, left, ot right
% Analyze 3 section of 20x20 pixels to determine which direction is
% clearest (straight is preferred)
while (((xCurrent > 0) && (xCurrent <= (numcol))) && ((yCurrent > 0) && (yCurrent <= (numrows))) && (stop == 0))
    i=0;
    j=0;
    rowTotal=0;
    total=0;
        % Calculate straight pixel matrix average
        while (i<20)
            while (j<20)
                rowTotal = rowTotal + A((xCurrent-10)+j,(yCurrent+i));
                j=j+1;
            end 
        
        i=i+1;
        total = total+rowTotal;
        end
        StraightAvg = total/400;
        
    i=0;
    j=0;
    rowTotal=0;
    total=0;
        
    % Calculate left pixel matrix average
        while (i<20)
            while (j<20)
                rowTotal = rowTotal + A((xCurrent-30)+j,(yCurrent+i));
                j=j+1;
            end 
        
        i=i+1;
        total = total+rowTotal;
        end
        LeftAvg = total/400;
        
    i=0;
    j=0;
    rowTotal=0;
    total=0;
        
    % Calculate right pixel matrix average
    if (((xCurrent > 20) && (xCurrent <= (numcol-20))) && ((yCurrent > 20) && (yCurrent <= numrows)))
        while (i<20)
            while ((j<20) && ((xCurrent+10+j) < 193))
                rowTotal = rowTotal + A((xCurrent+10)+j,(yCurrent+i));
                j=j+1;
            end 
        
        i=i+1;
        total = total+rowTotal;
        end
        RightAvg = total/400;   
    end   
    % Choose which direction (straight, left, or right)
    
    % Go straight first 
    if (((StraightAvg >= LeftAvg) && (StraightAvg >= RightAvg)) && (yCurrent>1) && (xCurrent>1))
        %Move forward (xCurrent Stays the same)
        yCurrent = yCurrent-1;
        B(yCurrent, xCurrent)=255;
    %else look to going right
    else
        if ((RightAvg > StraightAvg) && (yCurrent>1) && (xCurrent>1))
        yCurrent = yCurrent-1;
        xCurrent = xCurrent+1;
        B(yCurrent, xCurrent) = 255;
        else
            if ((LeftAvg > StraightAvg) && (yCurrent>1) && (xCurrent>1))
        yCurrent = yCurrent-1;
        xCurrent = xCurrent-1;
        B(yCurrent, xCurrent) = 255;    
     else        
            figure(2); imshow(B);
            stop = 255;
            end
        end
    end
end    

